   data:extend({

---raw-resource   

	{
		type = "item",
		name = "quartz",
		icon = "__SEDI__/graphics/icons/quartz.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "raw-resource",
		order = "a[stone]",
		stack_size = 200
	},   
   
---ore-processing
 	{
		type = "item",
		name = "titanium-rod",
		icon = "__SEDI__/graphics/icons/titanium-rod.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "ore-processing",
		order = "aa[iron-plate]",
		stack_size = 200
	},  

	{
		type = "item",
		name = "reprocessed-iron-compound",
		icon = "__SEDI__/graphics/icons/reprocessed-iron-compound.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "ore-processing",
		order = "a[iron-ore]",
		stack_size = 200
	},
		{
		type = "item",
		name = "reprocessed-copper-compound",
		icon = "__SEDI__/graphics/icons/reprocessed-copper-compound.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "ore-processing",
		order = "a[copper-ore]",
		stack_size = 200
	},
		{
		type = "item",
		name = "gold-nuggets",
		icon = "__SEDI__/graphics/icons/gold-nuggets.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "ore-processing",
		order = "ab[gold-nuggets]",
		stack_size = 200
	},

---raw-material

	{
		type = "item",
		name = "gold-plate",
		icon = "__SEDI__/graphics/icons/gold-plate.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "raw-material",
		order = "cb[gold-plate]",
		stack_size = 200
	},
	{
		type = "item",
		name = "silicon-rod",
		icon = "__SEDI__/graphics/icons/silicon-rod.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "raw-material",
		order = "cc[silicon-rod]",
		stack_size = 200
	},
   {
		type = "item",
		name = "titanium-plate",
		icon = "__SEDI__/graphics/icons/titanium-plate.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "raw-material",
		order = "ca[titanium-plate]",
		stack_size = 200
	},
---intermediate-product	

	{
		type = "item",
		name = "silicon-wafer",
		icon = "__SEDI__/graphics/icons/silicon-wafer.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "intermediate-product",
		order = "ca[advanced-circuit]",
		stack_size = 200
	},	
	{
		type = "item",
		name = "empty-circuit-board",
		icon = "__SEDI__/graphics/icons/empty-circuit-board.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "intermediate-product",
		order = "ba[electronic-circuit]",
		stack_size = 200
	},
	{
		type = "item",
		name = "gold-plated-copper-cable",
		icon = "__SEDI__/graphics/icons/gold-plated-copper-cable.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "circuit-network",
		order = "1[gold-plated-copper-cable]",
		stack_size = 200
	},
	{
		type = "item",
		name = "electric-motor",
		icon = "__SEDI__/graphics/icons/electric-motor.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "intermediate-product",
		order = "fa[engine-unit]",
		stack_size = 200
	},
	{
		type = "item",
		name = "laser-lense",
		icon = "__SEDI__/graphics/icons/laser-lense.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "intermediate-product",
		order = "k[laser-lense]",
		stack_size = 200
	},
	
---alien	
	
	{
		type = "item",
		name = "organic_samples",
		icon = "__SEDI__/graphics/icons/organic-samples.png",
		flags = {"goes-to-main-inventory"},
		subgroup = "raw-material",
		order = "fa[organic-samples]",
		stack_size = 1000
	},	
	{
    type = "item",
    name = "alien-spawner-egg",
    icon = "__SEDI__/graphics/icons/alien-spawner-egg.png",
    flags = {"goes-to-main-inventory"},
    subgroup = "raw-material",
    order = "h[alien-spawner-egg]",
    stack_size = 2,
    default_request_amount = 2
  },

---machines
  
  {
    type = "item",
    name = "stone-blast-furnace",
    icon = "__SEDI__/graphics/icons/stone-blast-furnace.png",
    flags = {"goes-to-quickbar"},
    subgroup = "smelting-machine",
    order = "ab[stone-blast-furnace]",
    place_result = "stone-blast-furnace",
    stack_size = 50
  },  
  
  {
    type = "item",
    name = "electric-blast-furnace",
    icon = "__SEDI__/graphics/icons/electric-blast-furnace.png",
    flags = {"goes-to-quickbar"},
    subgroup = "smelting-machine",
    order = "ca[electric-blast-furnace]",
    place_result = "electric-blast-furnace",
    stack_size = 50
  },  
  
  {
    type = "item",
    name = "acid-plant",
    icon = "__base__/graphics/icons/biter-spawner.png",
    flags = {"goes-to-quickbar"},
    subgroup = "production-machine",
    order = "ea[acid-plant]",
    place_result = "acid-plant",
    stack_size = 10
  },
  

	
	})