rf_pipepictures = function()
  return {
    straight_vertical_single =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-straight-vertical-single.png",
      priority = "extra-high",
      width = 44,
      height = 58
    },
    straight_vertical =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-straight-vertical.png",
      priority = "extra-high",
      width = 44,
      height = 42
    },
    straight_vertical_window =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-straight-vertical-window.png",
      priority = "extra-high",
      width = 44,
      height = 32
    },
    straight_horizontal_window =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-straight-horizontal-window.png",
      priority = "extra-high",
      width = 32,
      height = 42
    },
    straight_horizontal =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-straight-horizontal.png",
      priority = "extra-high",
      width = 32,
      height = 42
    },
    corner_up_right =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-corner-up-right.png",
      priority = "extra-high",
      width = 32,
      height = 40
    },
    corner_up_left =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-corner-up-left.png",
      priority = "extra-high",
      width = 44,
      height = 44
    },
    corner_down_right =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-corner-down-right.png",
      priority = "extra-high",
      width = 32,
      height = 32
    },
    corner_down_left =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-corner-down-left.png",
      priority = "extra-high",
      width = 36,
      height = 32
    },
    t_up =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-t-up.png",
      priority = "extra-high",
      width = 32,
      height = 42
    },
    t_down =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-t-down.png",
      priority = "extra-high",
      width = 40,
      height = 44
    },
    t_right =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-t-right.png",
      priority = "extra-high",
      width = 40,
      height = 32
    },
    t_left =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-t-left.png",
      priority = "extra-high",
      width = 44,
      height = 42
    },
    cross =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-cross.png",
      priority = "extra-high",
      width = 40,
      height = 40
    },
    ending_up =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-ending-up.png",
      priority = "extra-high",
      width = 44,
      height = 42
      },
    ending_down =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-ending-down.png",
      priority = "extra-high",
      width = 44,
      height = 32
    },
    ending_right =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-ending-right.png",
      priority = "extra-high",
      width = 32,
      height = 44
    },
    ending_left =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-ending-left.png",
      priority = "extra-high",
      width = 58,
      height = 44
    },
    horizontal_window_background =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-horizontal-window-background.png",
      priority = "extra-high",
      width = 32,
      height = 42
    },
    vertical_window_background =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/pipe-vertical-window-background.png",
      priority = "extra-high",
      width = 44,
      height = 32
    },
    fluid_background =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/fluid-background.png",
      priority = "extra-high",
      width = 32,
      height = 20
    },
    low_temperature_flow =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/fluid-flow-low-temperature.png",
      priority = "extra-high",
      width = 160,
      height = 18
    },
    middle_temperature_flow =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/fluid-flow-medium-temperature.png",
      priority = "extra-high",
      width = 160,
      height = 18
    },
    high_temperature_flow =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe/fluid-flow-high-temperature.png",
      priority = "extra-high",
      width = 160,
      height = 18
    }
  }
end

rf_pipecoverspictures = function()
  return {
    north =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe-covers/pipe-cover-north.png",
      priority = "extra-high",
      width = 44,
      height = 32
    },
    east =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe-covers/pipe-cover-east.png",
      priority = "extra-high",
      width = 32,
      height = 32
    },
    south =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe-covers/pipe-cover-south.png",
      priority = "extra-high",
      width = 46,
      height = 52
    },
    west =
    {
      filename = "__SEDI__/graphics/entity/rf-pipe-covers/pipe-cover-west.png",
      priority = "extra-high",
      width = 32,
      height = 32
    }
  }
end

data:extend({
---ITEM

  {
    type = "item",
    name = "rf-pipe",
    icon = "__SEDI__/graphics/icons/rf-pipe.png",
    flags = {"goes-to-quickbar"},
    subgroup = "energy-pipe-distribution",
    order = "a[pipe]-c[rf-pipe]",
    place_result = "rf-pipe",
    stack_size = 50
  },
  
  {
    type = "item",
    name = "rf-pipe-to-ground",
    icon = "__SEDI__/graphics/icons/rf-pipe-to-ground.png",
    flags = {"goes-to-quickbar"},
    subgroup = "energy-pipe-distribution",
    order = "a[pipe]-d[rf-pipe-to-ground]",
    place_result = "rf-pipe-to-ground",
    stack_size = 50
  },
  
  {
    type = "item",
    name = "rf-storage-tank",
    icon = "__SEDI__/graphics/icons/rf-storage-tank.png",
    flags = {"goes-to-quickbar"},
    subgroup = "storage",
    order = "b[fluid]-b[rf-storage-tank]",
    place_result = "rf-storage-tank",
    stack_size = 50
  },
  
---RECIPE

  {
    type = "recipe",
    name = "rf-pipe",
    enabled = "false",	
    ingredients = {
      {type="item", name="pipe", amount=2},
      {type="item", name="titanium-plate", amount=4},
	},
    result_count = 2,
    result = "rf-pipe"
  },
  
  {
    type = "recipe",
    name = "rf-pipe-to-ground",
	enabled = "false",
    energy_required = 1,
    ingredients =
    {
      {"rf-pipe", 25},
      {"steel-plate", 5}
    },
    result_count = 2,
    result = "rf-pipe-to-ground"
  },  
  
  {
    type = "recipe",
    name = "rf-storage-tank",
    energy_required = 6,
    enabled = "false",
    ingredients =
    {
      {"storage-tank", 1},
      {"titanium-plate", 30}
    },
    result= "rf-storage-tank"
  },

---TECH

  {
    type = "technology",
    name = "advanced-fluid-handling",
    icon = "__SEDI__/graphics/icons/advanced-fluid-handling.png",
    prerequisites = {"fluid-handling", "advanced-material-processing-2"},
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "rf-storage-tank"
      },
      {
        type = "unlock-recipe",
        recipe = "rf-pipe"
      },
	  {
        type = "unlock-recipe",
        recipe = "rf-pipe-to-ground"
      },
    },
    unit =
    {
      count = 75,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}},
      time = 30
    },
    order = "d-a-a"
  },

---ENTITY
  {
    type = "pipe",
    name = "rf-pipe",
    icon = "__SEDI__/graphics/icons/rf-pipe.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "rf-pipe"},
    max_health = 75,
    corpse = "small-remnants",
    resistances =
    {
      {
        type = "fire",
        percent = 90
      }
    },
    fast_replaceable_group = "pipe",
    collision_box = {{-0.29, -0.29}, {0.29, 0.29}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
    fluid_box =
    {
      base_area = 2,
      pipe_connections =
      {
        { position = {0, -1} },
        { position = {1, 0} },
        { position = {0, 1} },
        { position = {-1, 0} }
      },
    },
    pictures = rf_pipepictures(),
    working_sound =
    {
      sound = {
        {
          filename = "__base__/sound/pipe.ogg",
          volume = 0.65
        },
      },
      match_volume_to_activity = true,
      max_sounds_per_type = 3
    },
    horizontal_window_bounding_box = {{-0.25, -0.25}, {0.25, 0.15625}},
    vertical_window_bounding_box = {{-0.28125, -0.40625}, {0.03125, 0.125}}
  },
  
    {
    type = "pipe-to-ground",
    name = "rf-pipe-to-ground",
    icon = "__SEDI__/graphics/icons/rf-pipe-to-ground.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "rf-pipe-to-ground"},
    max_health = 75,
    corpse = "small-remnants",
    resistances =
    {
      {
        type = "fire",
        percent = 90
      }
    },
    collision_box = {{-0.29, -0.29}, {0.29, 0.2}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
    fluid_box =
    {
      base_area = 2,
      pipe_covers = rf_pipecoverspictures(),
      pipe_connections =
      {
        { position = {0, -1} },
        {
          position = {0, 1},
          max_underground_distance = 50
        }
      },
    },
    underground_sprite =
    {
      filename = "__core__/graphics/arrows/underground-lines.png",
      priority = "high",
      width = 32,
      height = 32
    },
    pictures =
    {
      up =
      {
        filename = "__SEDI__/graphics/entity/rf-pipe-to-ground/pipe-to-ground-up.png",
        priority = "high",
        width = 44,
        height = 32 --, shift = {0.10, -0.04}
      },
      down =
      {
        filename = "__SEDI__/graphics/entity/rf-pipe-to-ground/pipe-to-ground-down.png",
        priority = "high",
        width = 40,
        height = 32 --, shift = {0.05, 0}
      },
      left =
      {
        filename = "__SEDI__/graphics/entity/rf-pipe-to-ground/pipe-to-ground-left.png",
        priority = "high",
        width = 32,
        height = 42 --, shift = {-0.12, 0.1}
      },
      right =
      {
        filename = "__SEDI__/graphics/entity/rf-pipe-to-ground/pipe-to-ground-right.png",
        priority = "high",
        width = 32,
        height = 40 --, shift = {0.1, 0.1}
      },
    }
  },
  
    {
    type = "storage-tank",
    name = "rf-storage-tank",
    icon = "__SEDI__/graphics/icons/rf-storage-tank.png",
    flags = {"placeable-player", "player-creation"},
    minable = {hardness = 0.2, mining_time = 3, result = "rf-storage-tank"},
    max_health = 750,
    corpse = "medium-remnants",
    collision_box = {{-1.3, -1.3}, {1.3, 1.3}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    fluid_box =
    {
      base_area = 500,
      pipe_covers = rf_pipecoverspictures(),
      pipe_connections =
      {
        { position = {-1, -2} },
        { position = {2, 1} },
        { position = {1, 2} },
        { position = {-2, -1} },
      },
    },
	fast_replaceable_group = "storage-tank",
    picture =
    {
      sheet =
      {
        filename = "__SEDI__/graphics/entity/rf-storage-tank/rf-storage-tank.png",
        priority = "extra-high",
        frames = 2,
        width = 140,
        height = 115,
        shift = {0.6875, 0.109375}
      }
    },
    working_sound =
    {
      sound = {
          filename = "__base__/sound/storage-tank.ogg",
          volume = 0.8
      },
      apparent_volume = 1.5,
      max_sounds_per_type = 3
    },
  },
  })
  
data.raw["storage-tank"]["storage-tank"].fast_replaceable_group = {"storage-tank"}