data:extend(
{
   {
    type = "fluid",
    name = "iron_sludge",
    default_temperature = 25,
    heat_capacity = "50KJ",
    base_color = {r=0, g=0, b=0},
    flow_color = {r=0.67, g=0.75, b=0.77},
    max_temperature = 200,
    icon = "__SEDI__/graphics/icons/fluid/iron_sludge.png",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59,
	subgroup = "process_liquids",	
    order = "a[fluid]-ab[iron_sludge]"
  },
  {
    type = "fluid",
    name = "copper_sludge",
    default_temperature = 25,
    heat_capacity = "50KJ",
    base_color = {r=0, g=0, b=0},
    flow_color = {r=1.42, g=0.64, b=0.42},
    max_temperature = 200,
    icon = "__SEDI__/graphics/icons/fluid/copper_sludge.png",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59,
	subgroup = "process_liquids",	
    order = "a[fluid]-ac[copper_sludge]"
  },

  {
    type = "fluid",
    name = "separation_fluid",
    default_temperature = 25,
    heat_capacity = "0.5KJ",
    base_color = {r=0, g=0, b=0},
    flow_color = {r=2.30, g=2.20, b=0.11},
    max_temperature = 50,
    icon = "__SEDI__/graphics/icons/fluid/separation_fluid.png",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59,
	subgroup = "process_liquids",	
    order = "a[fluid]-aa[separation_fluid]"
  },  

  {
    type = "fluid",
    name = "extraction_fluid",
    default_temperature = 25,
    heat_capacity = "0.5KJ",
    base_color = {r=0, g=0, b=0},
    flow_color = {r=0, g=0, b=0.72},
    max_temperature = 50,
    icon = "__SEDI__/graphics/icons/fluid/extraction_fluid.png",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59,
	subgroup = "process_liquids",	
    order = "a[fluid]-ab[extraction_fluid]"
  },  
  
  })