--add loot item to small biters

local sbiter_loot = 
{
    item = "organic_samples",
    probability = 0.2,
    count_min = 0,
    count_max = 2 
}
local mbiter_loot = 
{
    item = "organic_samples",
    probability = 0.4,
    count_min = 1,
    count_max = 3 
}
local bbiter_loot = 
{
    item = "organic_samples",
    probability = 0.6,
    count_min = 1,
    count_max = 4 
}
local sspitter_loot = 
{
    item = "organic_samples",
    probability = 0.3,
    count_min = 1,
    count_max = 2 
}
local mspitter_loot = 
{
    item = "organic_samples",
    probability = 0.5,
    count_min = 1,
    count_max = 3 
}
local bspitter_loot = 
{
    item = "organic_samples",
    probability = 0.7,
    count_min = 2,
    count_max = 4 
}

local egg_loot = 
{
    item = "alien-spawner-egg",
    probability = 0.05,
    count_min = 1,
    count_max = 1 
}

if data.raw.unit["small-biter"].loot == nil then 
  data.raw.unit["small-biter"].loot = {}
end
if data.raw.unit["medium-biter"].loot == nil then 
  data.raw.unit["medium-biter"].loot = {}
end
if data.raw.unit["big-biter"].loot == nil then 
  data.raw.unit["big-biter"].loot = {}
end
if data.raw.unit["small-spitter"].loot == nil then 
  data.raw.unit["small-spitter"].loot = {}
end
if data.raw.unit["medium-spitter"].loot == nil then 
  data.raw.unit["medium-spitter"].loot = {}
end
if data.raw.unit["big-spitter"].loot == nil then 
  data.raw.unit["big-spitter"].loot = {}
end
table.insert(data.raw.unit["small-biter"].loot, sbiter_loot)
table.insert(data.raw.unit["medium-biter"].loot, mbiter_loot)
table.insert(data.raw.unit["big-biter"].loot, bbiter_loot)
table.insert(data.raw.unit["small-spitter"].loot, sspitter_loot)
table.insert(data.raw.unit["medium-spitter"].loot, mspitter_loot)
table.insert(data.raw.unit["big-spitter"].loot, bspitter_loot)

table.insert(data.raw["unit-spawner"]["spitter-spawner"].loot, egg_loot)
table.insert(data.raw["unit-spawner"]["biter-spawner"].loot, egg_loot)
