data:extend(
{
  {
    type = "autoplace-control",
    name = "water",
    richness = true,
    order = "b-e"
  },
{
    type = "noise-layer",
    name = "water"  
},  
  {
    type = "resource",
    name = "water",
    icon = "__SEDI__/graphics/icons/water.png",
    flags = {"placeable-neutral"},
    category = "basic-fluid",
    order="a-b-a",
    infinite = true,
    minimum = 1000,
    normal = 10000,
    minable =
    {
      hardness = 1,
      mining_time = 0.25,
      results =
      {
        {
          type = "fluid",
          name = "water",
          amount_min = 0.5,
          amount_max = 1.5,
          probability = 1
        }
      }
    },
    collision_box = {{ -1.4, -1.4}, {1.4, 1.4}},
    selection_box = {{ -0.5, -0.5}, {0.5, 0.5}},
    autoplace =
    {
      control = "water",
      sharpness = 1,
      max_probability = 0.03,
      richness_multiplier = 175000,
      richness_base = 7500,
      size_control_multiplier = 0.03,
      peaks =
      {
        {
          influence = 0.1
        },
        {
          influence = 0.105,
          starting_area_weight_optimal = 1,
          starting_area_weight_range = 0,
          starting_area_weight_max_range = 2,
        },
        {
          influence = 0.67,
          noise_layer = "water",
          noise_octaves_difference = -2.7,
          noise_persistence = 0.3
        }
      }
    },
    stage_counts = {0},
    stages =
    {
      filename = "__SEDI__/graphics/entity/water/water.png",
      priority = "extra-high",
      width = 75,
      height = 61,
      frame_count = 4,
      direction_count = 1
    },
    map_color = {r=0.0, g=0.0, b=0.2},
    map_grid = false
  }  
  
  
  
  })
